program bridge(input,output);

type row     = array[1..52] of char;
     serie   = array[1..13] of byte; 
     cardset = array[1..4] of serie;

const cardNames : array[1..13] of char = ('2','3','4','5','6','7','8','9','T','J','Q','K','A');
   colorNames :	array[1..4] of char    = ('C','D','S','H');
   playerNames : array[0..3] of char   = ('N','E','S','W');
var cards : cardset;		       

procedure writePlayerData(b : byte);
var i,j,k	: integer;
   first,second : row;
begin
   WriteLn('+---+---+---+---+---+---+---+---+---+---+---+---+---+');
   k:=1;
   for i:=1 to 4 do
    for j:=1 to 13 do 
     if cards[i,j]=b then
     begin
	first[k]:='|';          second[k]:='|'; k:=k+1;
	first[k]:=cardNames[j]; second[k]:=' '; k:=k+1;
	first[k]:=' ';          second[k]:=colorNames[i]; k:=k+1;
	first[k]:=cardNames[j]; second[k]:=' '; k:=k+1;
     end;
   WriteLn( first  + '|');
   WriteLn( second + '|');
   WriteLn( first  + '|');
   WriteLn('+---+---+---+---+---+---+---+---+---+---+---+---+---+');
end; { writePlayer }

function getColorNo(ch : char ):byte;
var i : integer;
begin
 i:=1;
 while (colorNames[i] <> ch) and ( i <= 4 ) do
  i:=i+1;
 getColorNo := i;
end; { getColorNo }

function getCardNo(ch : char ):byte;
var i : integer;
begin
 i:=1;
 while (cardNames[i] <> ch) and ( i <= 13 ) do
  i:=i+1;
 getCardNo := i;
end; { getCardNo }


procedure readDealing(var data :row;var dealingToPlayerNo : byte);
var i : integer;
begin
   for i:=0 to 25 do
   begin
      cards[getColorNo(data[i*2+1]),getCardNo(data[i*2+2])]:=dealingToPlayerNo;
      dealingToPlayerNo := (dealingToPlayerNo + 1) mod 4;
   end;
end; { readDealing }

function getDealingPlayerNo(dealingPlayer : char) :byte;
var i : integer;
begin
 i:=0;
 while (playerNames[i] <> dealingPlayer) and ( i < 4 ) do
    i:=i+1;
 getDealingPlayerNo := i;
end; { getDealingPlayerNo }

					    
var data	   : row;
   dealingPlayer   : char;
   dealingPlayerNo : byte;
begin
   readln( dealingPlayer);
   while( dealingPlayer <> '#') do
   begin
    dealingPlayerNo := getDealingPlayerNo( dealingPlayer);
    dealingPlayerNo := (dealingPlayerNo + 1) mod 4;
    readln( data );
    readDealing( data, dealingPlayerNo);
    readln( data );
    readDealing( data, dealingPlayerNo);
      
    WriteLn('South player:');
    writePlayerData( 2);
    WriteLn('West player:');
    writePlayerData( 3);
    
    WriteLn('North player:');
    writePlayerData( 0);
    WriteLn('East player:');
    writePlayerData( 1);
       
   readln( dealingPlayer);      
   if( dealingPlayer <> '#') then WriteLn;
   end;

end.






