/*
 *  Solution to the Store task
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXBAYS 1000
#define MAXGOODS 1000000
#define MAXTRUCKS 1000000
#define INFTY MAXTRUCKS+10

struct goods_s {
	int generation;
	int number;
};

struct bays_heap_s {
	int next_use;
	int bay;
};

int bays;
int bayg[MAXBAYS];
int baysame[MAXBAYS];
int trucks;
int truckg[MAXTRUCKS];
int goods;
int nextsame[MAXTRUCKS];
int heapn;
struct bays_heap_s heap[MAXBAYS+2];
int heappos[MAXBAYS];

struct goods_s goodspos[MAXGOODS];
int generation = 1;

void init_same(void)
{
	int i;

	for (i = trucks-1; i >= 0; i--) {
		if (goodspos[truckg[i]].generation < generation)
			nextsame[i] = INFTY;
		else
		    	nextsame[i] = goodspos[truckg[i]].number;
		goodspos[truckg[i]].number = i;
		goodspos[truckg[i]].generation = generation;
	}
	generation++;
}

int get_best_bay(void)
{
    	int ret = heap[1].bay, pos, next;
	struct bays_heap_s tmp;

	heap[1] = heap[heapn];
	heapn--;
	pos = 1;
	while (2*pos <= heapn) {
		next = pos;
		if (heap[2*pos].next_use > heap[pos].next_use)
		  	next = 2*pos;
		if (2*pos+1 <= heapn && heap[2*pos+1].next_use > heap[next].next_use)
		    	next = 2*pos+1;
		if (next == pos)
		    	break;
		tmp = heap[pos];
		heap[pos] = heap[next];
		heap[next] = tmp;
		heappos[heap[pos].bay] = pos;
		heappos[heap[next].bay] = next;
		pos = next;
	}
	return ret;
}

void bubble_bay(int pos, int bay, int next_use)
{
	while (pos > 1 && heap[pos >> 1].next_use < next_use) {
	    	heap[pos] = heap[pos >> 1];
	    	heappos[heap[pos].bay] = pos;
		pos = pos >> 1;
	}
	heap[pos].bay = bay;
	heap[pos].next_use = next_use;
    	heappos[bay] = pos;
}

void insert_bay(int bay, int next_use)
{
	bubble_bay(++heapn, bay, next_use);
}

int debug;

void process_case(void)
{
	int i, best, loadedbays = 0;

	heapn = 0;
	/* Process first requests to fill the bays*/
	for (i = 0; loadedbays < bays && i < trucks; i++) {
	    	if (goodspos[truckg[i]].generation < generation || goodspos[truckg[i]].number == -1) {
		    	printf("LOAD %d %d\n", loadedbays+1, truckg[i]);
			goodspos[truckg[i]].number = loadedbays;
			goodspos[truckg[i]].generation = generation;
			bayg[loadedbays] = truckg[i];
			insert_bay(loadedbays, nextsame[i]);
			loadedbays++;
		}
		else {
		    	puts("NO ACTION");
			bubble_bay(heappos[goodspos[truckg[i]].number], goodspos[truckg[i]].number, nextsame[i]);
		}
	}
	
	for (; i < trucks; i++) {
	    	if (goodspos[truckg[i]].generation == generation && goodspos[truckg[i]].number >= 0) {
		    	puts("NO ACTION");
			bubble_bay(heappos[goodspos[truckg[i]].number], goodspos[truckg[i]].number, nextsame[i]);
			continue;
		}
		best = get_best_bay();
		printf("LOAD %d %d\n", best+1, truckg[i]);
		goodspos[bayg[best]].number = -1;
		goodspos[truckg[i]].number = best;
		goodspos[truckg[i]].generation = generation;
		bayg[best] = truckg[i];
		insert_bay(best, nextsame[i]);
	}
	generation++;
}

int main(void)
{
	int cases, i, j;

	scanf("%d", &cases);
	for (i = 0; i < cases; i++) {
		printf("Case %d:\n", i+1);
		scanf("%d %d %d", &bays, &goods, &trucks);
		memset(bayg, 0, sizeof(int)*bays);
		for (j = 0; j < trucks; j++)
			scanf("%d", truckg+j);
		init_same();
		process_case();
		if (i < cases-1)
	    		putchar('\n');	    
	}
	return 0;
}
