program trafika;

{ Large version }

{
const	maxn = 20;
	maxstates = 1000000000;
}

{ Normal version }

const	maxn=20;				{ cars }
	maxstates=9765625;			{ states of game }

const	maxstw=(maxstates+31) div 16;		{ size of state bitmap }
	maxspc=6;				{ states per component }
	maxconf=63;				{ configs per row }

type	pic = longcard;
	bic = array [0..7] of byte;
	pb = ^bic;
	narray = array [1..maxspc+1] of byte;
	ctt = record
		s : array [1..maxspc] of record
			pos : array [1..2] of byte;
			neigh : array [0..maxconf] of narray;
			pix : cardinal;
			end;
		ns : cardinal;
		end;
	comt = record
		t : cardinal;
		code : cardinal;
		flip : boolean;
		row : cardinal;
		flipix : array [1..maxspc] of pic;
		codes : array [1..maxspc] of cardinal;
		end;
	stavec = array [1..maxn] of byte;

var	ct : array [1..6] of ctt;
	com : array [1..maxn] of comt;
	cst : stavec;
	bitmap : array [0..maxstw-1] of cardinal;
	nstates, nreach : integer;
	n, nc : integer;
	ini_state : integer;
	sce : integer;
	wincomp : integer;
	winmap : array [1..maxspc] of boolean;

procedure build;
var i,j,k,l,mask,x,pix1,pix2,m:integer;
begin
	with ct[1] do begin
		ns := 5;
		for i:=0 to 4 do begin
			s[i+1].pos[1] := i;
			s[i+1].pos[2] := 255;
			s[i+1].pix := $30 shr i;
			end;
		end;
	with ct[2] do begin
		ns := 4;
		for i:=0 to 3 do begin
			s[i+1].pos[1] := i;
			s[i+1].pos[2] := 255;
			s[i+1].pix := $38 shr i;
			end;
		end;
	with ct[3] do begin
		ns := 6;
		k := 0;
		for i:=0 to 4 do
			for j:=i+2 to 4 do begin
				inc(k);
				s[k].pos[1] := i;
				s[k].pos[2] := j;
				s[k].pix := ($30 shr i) or ($30 shr j);
				end;
		if k<>6 then begin writeln('argh 1'); halt(1); end;
		end;
	with ct[4] do begin
		ns := 3;
		k := 0;
		for i:=0 to 4 do
			for j:=i+2 to 3 do begin
				inc(k);
				s[k].pos[1] := i;
				s[k].pos[2] := j;
				s[k].pix := ($30 shr i) or ($38 shr j);
				end;
		if k<>3 then begin writeln('argh 2'); halt(1); end;
		end;
	with ct[5] do begin
		ns := 3;
		k := 0;
		for i:=0 to 3 do
			for j:=i+3 to 4 do begin
				inc(k);
				s[k].pos[1] := i;
				s[k].pos[2] := j;
				s[k].pix := ($38 shr i) or ($30 shr j);
				end;
		if k<>3 then begin writeln('argh 3'); halt(1); end;
		end;
	with ct[6] do begin
		ns := 1;
		s[1].pos[1] := 255;
		s[1].pos[2] := 255;
		s[1].pix := $3f;
		end;
	for i:=1 to 6 do
		with ct[i] do begin
			for j:=1 to ns do begin
				l := 0;
				for x:=0 to 5 do begin
					for k:=1 to ns do begin
						if (x <> s[j].pos[1]) and (s[k].pos[1] = x) and (s[k].pos[2] = s[j].pos[2]) then begin
							inc(l);
							s[j].neigh[0, l] := k;
							end;
						if (x <> s[j].pos[2]) and (s[k].pos[2] = x) and (s[k].pos[1] = s[j].pos[1]) then begin
							inc(l);
							s[j].neigh[0, l] := k;
							end;
						end;
					end;
				s[j].neigh[0, l+1] := 0;
				end;
			for mask:=1 to 63 do begin
				for j:=1 to ns do
					if (s[j].pix and mask) = 0 then begin
						k := 1;
						l := 0;
						while s[j].neigh[0,k] <> 0 do begin
							pix1 := s[j].pix;
							pix2 := s[s[j].neigh[0,k]].pix;
							m := pix1 or pix2 or ((pix1-1) xor (pix2-1));
							if (m and mask) = 0 then begin
								inc(l);
								s[j].neigh[mask,l] := s[j].neigh[0, k];
								end;
							inc(k);
							end;
						s[j].neigh[mask,l+1] := 0;
						end;
				end;
			end;
end;

procedure dumppic(var p:pic);
var	i, j: integer;
begin
	for i:=0 to 5 do begin
		for j:=0 to 5 do
			if (pb(@p)^[i] and ($20 shr j))<>0 then write('*') else write('.');
		write(' ');
		for j:=0 to 5 do
			if (pb(@p)^[j] and ($20 shr i))<>0 then write('*') else write('.');
		writeln;
	end;
end;

procedure read_game;
var	g : array [1..7] of string[7];
	i, j, k, l, p, npo, t, z : integer;
	flip : boolean;
	po, le, id : array [1..4] of integer;

	function d(x,y:integer):integer;
	var c:char;
	begin
		if not flip then c := g[x,y] else c := g[y,x];
		if c='x' then d := 1
		else if c >= 'a' then d := ord(c) - ord('a') + 2
		else if c = '.' then d := 0
		else begin writeln('grrr 1:', c); halt(1); end;
	end;
begin
	for i:=1 to 6 do begin
		readln(g[i]);
		g[i] := g[i] + '.';
		end;
	g[7] := '.......';
	nstates := 1;
	nc := 0;
	wincomp := 0;
	for flip := false to true do
		for i := 1 to 6 do begin
			j := 1;
			npo := 0;
			while j<=6 do
				if d(i,j)=0 then inc(j)
				else begin
					k := j;
					while d(i,k) = d(i,j) do
						inc(j);
					l := j-k;
					if l>1 then begin
						inc(npo);
						po[npo] := k-1;
						le[npo] := l;
						id[npo] := d(i,k);
						end;
					end;
			{ writeln('Row ', i, ': ', npo, ' cars'); }
			po[npo+1] := 255;
			id[npo+1] := 255;
			if npo=0 then t := 0
			else if (npo=1) and (le[1]=2) then t := 1
			else if (npo=1) and (le[1]=3) then t := 2
			else if (npo=2) and (le[1]=2) and (le[2]=2) then t := 3
			else if (npo=2) and (le[1]=2) and (le[2]=3) then t := 4
			else if (npo=2) and (le[1]=3) and (le[2]=2) then t := 5
			else if (npo=2) and (le[1]=3) and (le[2]=3) then begin
				if id[2]=1 then begin ini_state:=-1; exit; end;
				if id[1]=1 then begin ini_state:=-2; exit; end;
				t := 6;
				po[1]:=255; po[2]:=255;
				end
			else if (npo=3) and (le[1]=2) and (le[2]=2) and (le[3]=2) then begin
				if id[3]=1 then begin ini_state:=-1; exit; end;
				if id[2]=1 then begin ini_state:=-2; exit; end;
				if id[1]=1 then begin ini_state:=-2; exit; end;
				t := 6;
				po[1]:=255; po[2]:=255;
				end
			else begin
				writeln('Unknown trans!');
				halt(1);
			end;
			if t<>0 then begin
				inc(nc);
				{ writeln('Introduced component ', nc, ' of type ', t, ' at code ', nstates); }
				com[nc].t := t;
				com[nc].code := nstates;
				com[nc].row := i-1;
				com[nc].flip := flip;
				if id[npo]=1 then wincomp := nc;
				for k:=1 to ct[t].ns do begin
					com[nc].codes[k] := (k-1) * nstates;
					if (ct[t].s[k].pos[1] = po[1]) and (ct[t].s[k].pos[2] = po[2]) then begin
						{ writeln('Found component state ', k, ' of ', ct[t].ns); }
						cst[nc] := k;
						end;
					if wincomp=nc then
						winmap[k] := ct[t].s[k].pos[npo] = 6-le[1];
					p := ct[t].s[k].pix;
					for z := 0 to 5 do
						if (p and ($20 shr z))<>0 then
							pb(@com[nc].flipix[k])^[z] := $40 shr i
						else
							pb(@com[nc].flipix[k])^[z] := 0;
					end;
				nstates := nstates * ct[t].ns;
				end;
			end;
	{ writeln('Counted ', nstates, ' states'); }
	if wincomp=0 then begin
		ini_state := -2;
		exit;
		end;
	z := 0;
	for i:=1 to nc do
		z := z + com[i].codes[cst[i]];
	{ writeln('Starting in state ', z); }
	ini_state := z;
end;

var	pix : array[boolean] of pic;
	depth : integer;

function solve:boolean;
var	c, i, j, k : integer;
	nn, ost, oldcst, s, mix, odd, even : cardinal;
	bst, newcst, st : cardinal;
	co : ^comt;
	ctp : ^ctt;
	nar : ^narray;
begin
	depth := 0;
	nn := (nstates+31) div 16 - 1;
	for i:=0 to nn do bitmap[i] := 0;
	bitmap[ini_state div 16] := 3 shl (2*(ini_state mod 16));
	nreach := 1;
	while true do begin
		{ writeln('Entering depth ', depth); }
		mix := 0;
		for i:=0 to nn do begin
			odd := bitmap[i] and $aaaaaaaa;
			even := bitmap[i] and $55555555;
			bitmap[i] := ((odd shr 1) xor even) or (odd and (even shl 1));
			{ 00 -> 00, 01 -> 01, 10 -> 01, 11 -> 10 }
			mix := mix or bitmap[i];
		end;
		if (mix and $aaaaaaaa)=0 then begin
			solve := false;
			exit;
			end;
		for i:=0 to nn do
			if ((not bitmap[i]) and (bitmap[i] shr 1) and $55555555)<>0 then
				for j:=0 to 15 do
					if ((bitmap[i] shr (2*j)) and 3) = 2 then begin
						ost := 16*i + j;
						{ writeln('Recognized state ', ost); }
						s := ost;
						pix[false] := 0;
						pix[true] := 0;
						for c:=1 to nc do begin
							co := @com[c];
							ctp := @ct[co^.t];
							cst[c] := 1 + s mod ctp^.ns;
							s := s div ctp^.ns;
							pix[not co^.flip] := pix[not co^.flip] or co^.flipix[cst[c]];
							end;
						if winmap[cst[wincomp]] then begin
							solve := true;
							exit;
							end;
						for c := 1 to nc do begin
							co := @com[c];
							ctp := @ct[co^.t];
							oldcst := cst[c];
							bst := ost - co^.codes[oldcst];
							k := 1;
							nar := @ctp^.s[oldcst].neigh[pb(@pix[co^.flip])^[co^.row]];
							while nar^[k]<>0 do begin
								newcst := nar^[k];
								st := bst + co^.codes[newcst];
								{ writeln('Can reach state ', newcst, ' in comp ', c, ' -> ', st); }
								if ((bitmap[st div 16] shr (2*(st mod 16))) and 3) = 0 then begin
									bitmap[st div 16] := bitmap[st div 16] or (3 shl (2*(st mod 16)));
									inc(nreach);
									end;
								inc(k);
								end;
							end;
						end;
		inc(depth);
		end;
end;

begin
	build;
	sce := 0;
	while true do begin
		inc(sce);
		readln(n);
		if n=0 then halt;
		read_game;
		if (ini_state = -1) or (ini_state >= 0) and solve then
			writeln('Scenario #', sce, ' requires ', depth, ' moves.')
		else
			writeln('You are trapped in scenario #', sce, '.');
		{ writeln('Reachable states: ', nreach); }
		end;
end.

